#pragma once

/**
 * @file
 * @author  Chanwoo Kim (chanwook@cs.cmu.edu)
 * @version 1.0
 *
 * @section LICENSE
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details at
 * http://www.gnu.org/copyleft/gpl.html
 *
 * @section DESCRIPTION
 *
 * 
 */

#include "HLabCompMVConfig.h"
#include "HLabFeat.h"
#include "HLabPhoneList.h"
#include "HLabDict.h"
#include "HLabControl.h"
#include "HLabTranscription.h"
#include "HLabHMM.h"



class CHLabCompMV
{
	CHLabCompMVConfig  m_compMVConfig;
	CHLabPhoneList     m_phoneList;
	CHLabDict          m_dict;
	CHLabControl       m_control;
	CHLabTranscription m_transcription;
	CHLabHMM*          m_pHMM;

public:
	CHLabCompMV(void);
	
	int ParseCommandLine(int argc, char** argv);

	 /**
      * Init
      * 
      * @param 
      * @return 
      */

	int Init(void);

	 /**
      * Run
      * 
      * @param 
      * @return 
      */
	int Run(void);

	virtual ~CHLabCompMV(void);
};
