#include "HLabDTWRecogConfig.h"

CHLabDTWRecogConfig::CHLabDTWRecogConfig(void) :
	m_pszInputFile(NULL)
{
}

CHLabDTWRecogConfig::~CHLabDTWRecogConfig(void)
{
}


arg_t CHLabDTWRecogConfig::m_defn[] = 
{
	{"-phnlstfn",
	ARG_STRING,
	NULL,
	"PHoNe LiST File Name"},

	{"-dictfn",
	ARG_STRING,
	NULL,
	"DICTionary File Name"},

	{"-featext",
	ARG_STRING,
	"mfc",
	"Feature extention"},

	{"-featdir",
	ARG_STRING,
	NULL,
	"Feature directory"},

	{"-ctlfn",
	ARG_STRING,
	NULL,
	"Control File Name"},

	{"-lsnfn",
	ARG_STRING,
	NULL,
	"Transcription File Name (Format should be in NIST Lexical Standard Normal Orthographic Representation (LSN))"},

    {"-beamth",
	ARG_FLOAT64,
	"100.0",
	"Beam threshold"},

	{"-i",
	ARG_STRING,
	NULL,
	"Test feature file name"},

	{ NULL, 0,  NULL, NULL }
};



int CHLabDTWRecogConfig::ParseCommandLine(int argc, char** argv)
{
	print_appl_info(argv[0]);

	cmd_ln_appl_enter(argc, argv, "default.arg", m_defn);


	m_pszPhoneFile         = cmd_ln_str("-phnlstfn");
	m_pszDictFile          = cmd_ln_str("-dictfn");
	m_pszControlFile       = cmd_ln_str("-ctlfn");
	m_pszLSNFile           = cmd_ln_str("-lsnfn");
	m_pszFeatDir           = cmd_ln_str("-featdir");
	m_pszFeatExt           = cmd_ln_str("-featext");
	m_pszInputFile         = cmd_ln_str("-i");
	m_fPruneTH             = cmd_ln_float32("-beamth");
	
	print_appl_info(argv[0]);

	return (0);
}