#include "HLabBPTable.h"
#include "libutil.h"

CHLabBPTableNode::CHLabBPTableNode(void)
  : m_iWordID(0),
	m_iFrameIndex(0),
	m_dPathScore(0.0),
	m_iPredNodeID(0)
{
}

CHLabBPTableNode::~CHLabBPTableNode(void)
{
}

CHLabBPTable::CHLabBPTable(void)
{
}

CHLabBPTable::~CHLabBPTable(void)
{
}

std::vector<int> CHLabBPTable::BackTracking(int iIndex)
{
	
	std::vector<int> vecResultBuffer;
	std::vector<int>::iterator itr;
	int i;

	vecResultBuffer.clear();
	m_vecBacktrackResult.clear();

	/* backtracking using the back-pointer */
	CHLabBPTableNode BPTableNode = m_vecBPNode[iIndex];
	vecResultBuffer.push_back(BPTableNode.m_iWordID);
	int iPrevID              = BPTableNode.m_iPredNodeID;

	while (iPrevID > 0)
	{
		BPTableNode = m_vecBPNode[iPrevID];
		iPrevID     = BPTableNode.m_iPredNodeID;
		vecResultBuffer.push_back(BPTableNode.m_iWordID);
	}

	/* reversed sequence is obtained */
	for (i = 0; i < vecResultBuffer.size(); i++)
	{
		m_vecBacktrackResult.push_back(vecResultBuffer[ vecResultBuffer.size() - 1 - i]);
	}

	return m_vecBacktrackResult;
}


int CHLabBPTable::BackTrackingPhoneNumber(int iIndex)
{
	int aiTempBuffer[100];
	int aiFinalBuffer[100];
	int iCount;
	int iCountSave = -1;

	
	int i, j;
	int iStart;
	int iShift;
	int iNumCount;
	float fBestScore = -HLab_INFINITY;

	printf("==========================================================\n");
	printf(" Phone number decoding \n");
	printf("==========================================================\n");

	/* Let's do exhaustive search */
	for (iStart = (int)(iIndex) ; iStart <= iIndex; iStart++)
	{
		int bFlag = 0;
		CHLabBPTableNode BPTableNode = m_vecBPNode[iStart];
		aiTempBuffer[0]          = BPTableNode.m_iWordID;
		int iPrevID              = BPTableNode.m_iPredNodeID;

		iCount = 1;

		while (iPrevID > 0)
		{
			BPTableNode = m_vecBPNode[iPrevID];

			iPrevID = BPTableNode.m_iPredNodeID;

			aiTempBuffer[iCount++] = BPTableNode.m_iWordID;
		}

		for (i = 0; i < iCount; i++)
		{
			aiFinalBuffer[i] = aiTempBuffer[(iCount - 1) - i];
		}
			
	}


	iNumCount = 0;

	for (i = 0; i < iCount; i++)
	{
		if (aiFinalBuffer[i] != 10) /* Silence is excluded */
			iNumCount++;
	}

	printf("NUMBERS: %d\n", iNumCount);

	if (iNumCount < 7)
	{
		E_WARN("Failed to satisfy the FSN. Change beam or insertion penalty\n\n");

		printf("[RESULT] WARN  Failed to satisfy FSN change beam or insertion penalty : ");

		for (iCount = 0, j = 0; iCount < iNumCount; j++)
		{
			if (aiFinalBuffer[j] < 10)
			{
				iCount++;
				printf("%d ", aiFinalBuffer[j]);
			}
		}
		printf("\n");
	}
	
	if (iNumCount >= 7 &&  iNumCount < 10)
	{
		printf("[RESULT] ");

		for (iCount = 0, j = 0; iCount < 7; j++)
		{
			if (aiFinalBuffer[j] < 10)
			{
				iCount++;
				printf("%d ", aiFinalBuffer[j]);
			}
		}
		printf("\n");
	}
	
	if (iNumCount >= 10)
	{
		printf("[RESULT] ");

		for (iCount = 0, j = 0; iCount < 10; j++)
		{
			if (aiFinalBuffer[j] < 10)
			{
				iCount++;
				printf("%d ", aiFinalBuffer[j]);
			}
		}
		printf("\n");
		
	}
	

	
	
	
	return (0);
}

#if 0

int CHLabBPTable::BackTracking(int iIndex)
{
	CHLabBPTableNode BPTableNode = m_vecBPNode[iIndex];

	printf("[BACKTRACK : WORD ID] %d\n", BPTableNode.m_iWordID);
	printf("[BACKTRACK : PREVNODE ID] %d\n", BPTableNode.m_iPredNodeID);

	int iPrevID = BPTableNode.m_iPredNodeID;

	while (iPrevID > 0)
	{
		BPTableNode = m_vecBPNode[iPrevID];

		printf("[BACKTRACK : WORD ID] %d\n", BPTableNode.m_iWordID);
		printf("[BACKTRACK : PREVNODE ID] %d\n", BPTableNode.m_iPredNodeID);

		iPrevID = BPTableNode.m_iPredNodeID;
	}

	return (0);
}

#endif
