#pragma once

#include <vector>

#include "HLabConst.h"

#ifdef WIN32
	#if defined _USRDLL 
		#define DllExport _declspec(dllexport)
	#else
		#define DllExport _declspec(dllimport)
	#endif 
#else
	#define DllExport
#endif


//////////////////////////////////////////////////////////////////////

/**
 * @file
 * @author  Chanwoo Kim (chanwook@cs.cmu.edu)
 * @version 1.0
 *
 * @section LICENSE
 *
 *
 * @section DESCRIPTION
 *
 * 04-20-2010 backtracking is now returning the phone ID sequence instead of printing the result. 
 *
 */

class DllExport CHLabBPTableNode
{

public:
	int    m_iWordID;
	int    m_iFrameIndex;
	double m_dPathScore;
	int    m_iPredNodeID;


	CHLabBPTableNode(void);
	~CHLabBPTableNode(void);
};


class DllExport CHLabBPTable
{
public:
	std::vector<CHLabBPTableNode> m_vecBPNode;
	std::vector<int>              m_vecBacktrackResult;
public:
	CHLabBPTable(void);
	~CHLabBPTable(void);

	inline int GetNumBPNode()
	{
		return m_vecBPNode.size();
	}

	inline int push_back(CHLabBPTableNode tableNode)
	{
		m_vecBPNode.push_back(tableNode);

		return (0);
	}

	std::vector<int>  BackTracking(int iIndex);
	int BackTrackingPhoneNumber(int iIndex);
};
