#pragma once

/**
* @file
* @author  Chanwoo Kim (chanwook@cs.cmu.edu)
* @version 1.0
*
* @section LICENSE
*
* @section DESCRIPTION
*
* The CHLabCompMVConfig class contains configuration related to HLabCompMV
*
*/

#define MAX_PHONE 50
#define MAX_LINE  1000

const float HLab_INFINITY     = 1e10;
const int   MAX_NUM_STATES    = 5;
const int   MAX_FEAT_DIM      = 100;
const int   DEFAULT_FEAT_LEN  = 13;

const int   MAX_LINE_LEN      = 500;



#define SQ(X) ((X) * (X))

#define MAX2(X, Y) (((X) > (Y))? (X) : (Y))
#define MAX3(X, Y, Z) (MAX2(MAX2(X, Y), Z))

#define MIN2(X, Y) (((X) < (Y))? (X) : (Y))
#define MIN3(X, Y, Z) (MIN2(MIN2(X, Y), Z))

