#pragma once

#include <cstdio>
#include <cstdlib>


#include "libutil.h"

#ifdef WIN32
	#if defined _USRDLL 
		#define DllExport _declspec(dllexport)
	#else
		#define DllExport _declspec(dllimport)
	#endif 
#else
	#define DllExport 
#endif


class DllExport CHLabDTW
{
	const float*** m_pppfTestFeat;
	const float*** m_pppfRefFeat;

	int m_iTestFeatLen;
	int m_iRefFeatLen;
	int m_iTestFeatDim;
	int m_iRefFeatDim;

	int m_iT;
	float m_fBestScore;

	const float INF;
	
	

	float**  m_ppfScoreTable;
	float*   m_pfLocalDist;

	float    m_fPruneTH;



public:
	CHLabDTW(void);
	virtual ~CHLabDTW(void);

	void SetTestFeat(const float*** pppfTestFeat, int iTestFeatLen, int iTestFeatDim)
	{
		m_pppfTestFeat = pppfTestFeat;
		m_iTestFeatLen = iTestFeatLen;
		m_iTestFeatDim = iTestFeatDim;
	}

	void SetRefFeat(const float*** pppfRefFeat, int iRefFeatLen, int iRefFeatDim)
	{
		m_pppfRefFeat = pppfRefFeat;
		m_iRefFeatLen = iRefFeatLen;
		m_iRefFeatDim = iRefFeatDim;
	}

	int Init(void);
	
	float Run(float fTH);

	float EuclideanDistance(int iTestFrameIndex, int iRefFrameIndex);

	float GetFinalScore(void);
	
	
};
