#include "HLabDict.h"
#include "libutil.h"

CHLabDict::CHLabDict(void) :
	m_pPhoneList(NULL)
{
}

CHLabDict::~CHLabDict(void)
{
	
}

int CHLabDict::SetPhoneList(CHLabPhoneList* pPhoneList)
{
	if (pPhoneList == NULL)
	{
		fprintf(stderr, "[FATAL], invalid phone class pointer");

		exit (0);
	}

	if (pPhoneList->GetNumPhones() <= 0)
	{
		fprintf(stderr, "[FATAL], invalid number of phones");

		exit (0);
	}


	m_pPhoneList = pPhoneList;

	
}


std::string CHLabDict::GetDictSymbol(int iWordID)
{
	std::map< std::string, vector<int> >::iterator itr;
	int bFound = 0;
	int iIndex;

	iIndex = 0;
	
	for (itr = m_mapDicWords.begin(); itr !=  m_mapDicWords.end(); itr++)
	{
		if (iIndex == iWordID)
		{
			return (*itr).first;
			bFound = 1;
		}

		iIndex++;
	}

	E_FATAL("The phone ID %d cannot be found", iWordID);

	return NULL;
}

int CHLabDict::ReadDictFile(const char* szFileName)
{
	
	FILE* pFile = NULL;

	pFile = fopen(szFileName, "rb");

	if (pFile == NULL)
	{
		fprintf(stderr, "[FATAL], File cannot be opened.\n");

		exit (0);
	}

	if (m_pPhoneList == NULL)
	{
		fprintf(stderr, "[FATAL], invalid phone class pointer");

		exit (0);
	}

	char* pszBuffer1;
	char* pszBuffer2;
	char  acBuffer[MAX_LINE];
	char  acWord[MAX_LINE];
	int   iLen;
	char seps[]   = " ,\t\n\r";

	m_iNumDicWords = 0;
	char* pszToken;
	vector<int> vecPhoneSeq;
	int         iPhoneID;

	printf("Reading the dictionary \n");


	while (fgets(acBuffer, MAX_LINE, pFile) != NULL)
	{
		pszToken = strtok(acBuffer, seps);

		sscanf(acBuffer, "%s", acWord);

	
		vecPhoneSeq.clear();

		while (pszToken != NULL)
		{
			
			pszToken = strtok(NULL, seps);

			if (pszToken != NULL)
			{
				iPhoneID = m_pPhoneList->GetPhoneID(pszToken);

				vecPhoneSeq.push_back(iPhoneID);
			}
		}
		
		m_iNumDicWords++;

		m_mapDicWords[acWord] = vecPhoneSeq;
	}

	


	return (0);
}

std::vector<int> CHLabDict::GetDictWords(const char* szWord)
{
	vector<int> vecPhoneSeq = m_mapDicWords[szWord];

	return (vecPhoneSeq);
}

int CHLabDict::ListDicWords(void)
{
	std::map<string, vector<int> >::iterator itr;
	std::vector<int>           vecPhoneID;
	std::vector<int>::iterator itrPhoneID;

	printf("+++DICT WORD LIST+++\n");

	printf("Total number of words in the dictionary is %d\n", m_iNumDicWords);

	for (itr = m_mapDicWords.begin(); itr !=  m_mapDicWords.end(); itr++)
	{
		
		std::cout << (*itr).first << '\t';

		vecPhoneID = (*itr).second;

		for (itrPhoneID = vecPhoneID.begin(); itrPhoneID < vecPhoneID.end(); itrPhoneID++)
		{
			std::cout << (*itrPhoneID) << " ";
		}

		std::cout << std::endl;

	}

	

	return (0);

}
