#pragma once

#include <iostream>
#include <vector>
#include <map>
#include <string>

using namespace std;

#ifdef WIN32
	#if defined _USRDLL 
		#define DllExport _declspec(dllexport)
	#else
		#define DllExport _declspec(dllimport)
	#endif 
#else
	#define DllExport
#endif

#include "HLabConst.h"
#include "HLabPhoneList.h"

/* Storing words in a vector is not an efficient way */
/* Later, I need to do re-implmenet it using a Hash data structure */

class DllExport CHLabDict
{
	int m_iNumDicWords;


	//std::vector<char*> m_vecDicWords;
	//std::map<char*, int> m_mapDicWords; /* Using map is not a very good choice */
	std::map< std::string, vector<int> > m_mapDicWords;
	CHLabPhoneList*              m_pPhoneList;
	
public:
	CHLabDict(void);
	~CHLabDict(void);

	int SetPhoneList(CHLabPhoneList* pPhoneList);
	int ReadDictFile(const char* szFileName);
	int ListDicWords(void);
	std::vector<int> GetDictWords(const char* szWord);


	std::string GetDictSymbol(int iID);

	inline int GetNumDictWords(void)
	{
		return m_iNumDicWords;
	}

	inline std::map< std::string, vector<int> >& GetMapDicWords(void)
	{
		return m_mapDicWords;
	}

	

	
};
