#pragma once

#include <vector>

#ifdef WIN32
	#if defined _USRDLL 
		#define DllExport _declspec(dllexport)
	#else
		#define DllExport _declspec(dllimport)
	#endif 
#else
	#define DllExport 
#endif

/**
 * @file
 * @author  Chanwoo Kim (chanwook@cs.cmu.edu)
 * @version 1.0
 *
 * @section LICENSE
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details at
 * http://www.gnu.org/copyleft/gpl.html
 *
 * @section DESCRIPTION
 *
 * 
 */

class DllExport CHLabFeat
{
	int m_bByteSwap;

	
public:

	int m_iCepDim;
	int m_iFeatDim;
	int m_iLen;

	float** m_ppfFeat;
	CHLabFeat(void);
	virtual ~CHLabFeat(void);

	int  ReadFeatFile(const char* pszFile, int iDim);

	/**
	* GetLen
	* 
	* @param 
	* @return 
	*/

	inline int GetLen(void)
	{
		return m_iLen;
	}

	/**
	* GetLen
	* 
	* @param 
	* @return 
	*/

	inline int GetFeatDim(void)
	{
		return m_iFeatDim;
	}

	inline int GetCepDim(void)
	{
		return m_iCepDim;
	}
	
	int  GetFileSize(const char* pszFeatFile);
};
