#pragma once

///////////////////////////////////////////////////////////////////////
//
//
// Programmed by Chanwoo Kim
//
// How to use
//
// 00. CFeat* pFeat
//
// 01. pFeat->Init....
//
// 02. pFeat->WriteVec or pFeat->ReadVec
//
// ** Caution: except special cases, you don't need to call WriteHeader or CloseFile
//

#include <cstdio>
#include <vector>

#include "fe.h"
#include "libutil.h"

class CFeature
{
	FILE* m_pFeatFile;

	int32 GetFileSize(const char* pszFeatFile);
	int32 m_iByteSwap;
	
public:

	enum FEAT_MODE
	{
		FEAT_READ,
		FEAT_WRITE,
	} m_featMode;

	const char* m_pszFeatFile;
	int   m_iDim;
	int   m_iNumVec;

	CFeature();
	~CFeature();

	int32 Init(const char* pszFeatFile, int iDim, FEAT_MODE featMode = FEAT_READ);
	int32 WriteVec(float32* pfVec);
	

	int32 ReadVec(float32* pf_x, int32 i_x_Len);
	int32 WriteHeader(void);
	int32 CloseFile(void);
};