#pragma once

#ifdef WIN32
	#if defined _USRDLL 
		#define DllExport _declspec(dllexport)
	#else
		#define DllExport _declspec(dllimport)
	#endif 
#else
	#define DllExport
#endif



class  DllExport CHLabHMM
{
	 char*   m_pszName;

public:
	int     m_iDim;
	int     m_iNumStates;
	float** m_ppfMean;
	float** m_ppfVar;
	float** m_ppfTrans;
	
public:

	int SetDefaultTrans(void);

	CHLabHMM(void);

	int Init(int iDim, int iNumStates, const char* pszName);

	void SetMean(float  fData, int i, int j)
	{
		m_ppfMean[i][j] = fData;
	}
	void SetVar(float   fData, int i, int j)
	{
		m_ppfVar[i][j]  = fData;
	}
	void SetTrans(float fData, int i, int j)
	{
		m_ppfTrans[i][j] = fData;
	}

	inline int GetNumStates()
	{
		return m_iNumStates;
	}


	int ReadHMM(const char* szDir);
	int WriteHMM(const char* szDir);
	
	virtual ~CHLabHMM(void);
};
