#pragma once

#include <string>
#include <iostream>


#ifdef WIN32
	#if defined _USRDLL 
		#define DllExport _declspec(dllexport)
	#else
		#define DllExport _declspec(dllimport)
	#endif 
#else
	#define DllExport
#endif

#ifdef WIN32
	#include <unordered_map>
#else
	#include <tr1/unordered_map>
#endif

struct LM_PROB
{
	float m_fLogProb;
	float m_fLogBackOff;
};

class DllExport CHLabLM
{

	 std::tr1::unordered_map<std::string, LM_PROB> m_hashTrigram;
	 std::tr1::unordered_map<std::string, LM_PROB> m_hashBigram;
	 std::tr1::unordered_map<std::string, LM_PROB> m_hashUnigram;

public:
	CHLabLM(void);
	virtual ~CHLabLM(void);

	int ReadLM(const char* szFile);

	LM_PROB ComputeTrigramProb(std::string strTrigram);
	LM_PROB ComputeBigramProb (std::string strBigram);
	LM_PROB ComputeUnigramProb(std::string strBigram);
	float ComputeBigramProb();
};
