#include <cstdio>

#include "libutil.h"

#include "HLabPhoneList.h"



CHLabPhoneList::CHLabPhoneList(void) :
	m_iNumPhones(0)
	
{
}

CHLabPhoneList::~CHLabPhoneList(void)
{

	
}

int CHLabPhoneList::ReadPhoneFile(const char* szFileName)
{
	
	FILE* pFile = NULL;

	if (szFileName == NULL)
	{
		fprintf(stderr, "[FATAL], Phone Filename has not been set\n");

		exit (0);
	}

	pFile = fopen(szFileName, "rb");

	

	if (pFile == NULL)
	{
		fprintf(stderr, "[FATAL], File cannot be opened.\n");

		exit (0);
	}


	char  acBuffer[MAX_LINE];
	m_iNumPhones = 0;

	while (fscanf(pFile, "%s", acBuffer) == 1)
	{
		m_mapPhones[acBuffer] = m_iNumPhones;

		m_iNumPhones++;
	}


	return (m_iNumPhones);
}

int CHLabPhoneList::ListPhones(void)
{
	printf("+++PHONE LIST+++\n");

	std::map<std::string, int>::iterator itr;
	
	for (itr = m_mapPhones.begin(); itr !=  m_mapPhones.end(); itr++)
	{
		std::cout << (*itr).first << std::endl;
	}

	return (0);
}

int CHLabPhoneList::GetPhoneID(std::string strPhone)
{
	std::map<std::string, int>::iterator itr;
	int iPhoneID;

	iPhoneID = -1;


	iPhoneID = m_mapPhones[strPhone];


//
	return (iPhoneID);

}

std::string CHLabPhoneList::GetPhoneSymbol(int iPhoneID)
{
	std::map<std::string, int>::iterator itr;
	int bFound = 0;
	
	for (itr = m_mapPhones.begin(); itr !=  m_mapPhones.end(); itr++)
	{
		if ((*itr).second == iPhoneID)
		{
			return (*itr).first;
			bFound = 1;
		}
	}

	E_FATAL("The phone ID %d cannot be found", iPhoneID);

	return NULL;
}
