#pragma once

#include <vector>
#include <map>
#include <string>
#include <iostream>

#ifdef WIN32
	#if defined _USRDLL 
		#define DllExport _declspec(dllexport)
	#else
		#define DllExport _declspec(dllimport)
	#endif 
#else
	#define DllExport
#endif


#include "HLabConst.h"




class DllExport CHLabPhoneList
{
	int                m_iNumPhones;


	std::map<std::string, int> m_mapPhones;
public:
	CHLabPhoneList(void);
	~CHLabPhoneList(void);

	int ReadPhoneFile(const char* szFileName);
	int ListPhones(void);

	// Phone information is stored as an integer value
	int         GetPhoneID(std::string strPhone);
	std::string GetPhoneSymbol(int iID);

	inline int GetNumPhones(void)
	{
		return m_iNumPhones;
	}
};
