#pragma once

#include <iostream>
#include <map>
#include <string>

#include "HLabConst.h"
#include "HLabPhoneList.h"
#include "HLabDict.h"

/**
* @file
* @author  Chanwoo Kim (chanwook@cs.cmu.edu)
* @version 
*  04-07-2010 ReadTranscriptionFileLine is added
*  03-20-2010 File Created
*
* @section LICENSE
*
* @section DESCRIPTION
*
* The CHLabTranscription class processes transcription
*
*/

#ifdef WIN32
	#if defined _USRDLL 
		#define DllExport _declspec(dllexport)
	#else
		#define DllExport _declspec(dllimport)
	#endif 
#else
	#define DllExport
#endif


class  DllExport  CHLabTranscription
{
	CHLabPhoneList*              m_pPhoneList;
	CHLabDict*                   m_pDict;
	int                          m_iLen;
	FILE*                        m_pTransFile;

	//std::map<std::string, vector<int>> m_mapTranscription;
	std::vector<vector<int> > m_vecTranscription;
	std::vector<int> m_vecTranscriptionLine;

public:
	CHLabTranscription(void);

	int Init(const char* pszTransFileName);

	int SetPhoneList(CHLabPhoneList* pPhoneList);
	int SetDictList(CHLabDict*      pDict);
	int ReadTranscriptionFile(const char* pszFileName);
	std::vector<int> ReadTranscriptionFileLine(void);
	int ListTranscription(void);

	virtual ~CHLabTranscription(void);
};
