#pragma once

#ifdef WIN32
	#if defined _USRDLL 
		#define DllExport _declspec(dllexport)
	#else
		#define DllExport _declspec(dllimport)
	#endif 
#endif

#include "HLabHMM.h"
#include "HLabFeat.h"
#include "HLabConst.h"
#include "HLabViterbi.h"

/**
* @file
* @author  Chanwoo Kim (chanwook@cs.cmu.edu)
* @version 1.0
*
* @section LICENSE
*
* @section DESCRIPTION
*
* The CHLabWordViterbi class is for constructing a super-HMM
*
*
*/


class DllExport CHLabWordViterbi
{
	const CHLabHMM*            m_pHMM;
	int                        m_iNumHMMs;
	std::vector<int>           m_vecHMMIndex;
	const CHLabFeat*           m_pFeat;
	CHLabViterbi*              m_pViterbi;
	int                        m_iTI;
	

public:
	CHLabWordViterbi(void);


	int Init(const CHLabHMM* pHMM, 
		    int iNumHMMs,
			std::vector<int> vecHMMIndex,
		    const CHLabFeat* pFeat);

	float Run(float* pfOutLikelihood, int* piOutBackPointer,
			  float* pfHighestLikelihood,
 		      float fInLikelihood,    int iInBackPointer, float fTH = -HLab_INFINITY);

	virtual ~CHLabWordViterbi(void);
};
