#pragma once

#include "HLabViterbiRecogConfig.h"
#include "HLabFeat.h"
#include "HLabPhoneList.h"
#include "HLabDict.h"
#include "HLabControl.h"
#include "HLabTranscription.h"
#include "HLabHMM.h"
#include "HLabViterbi.h"
#include "HLabWordViterbi.h"
#include "HLabBPTable.h"
#include "HLabLM.h"

class CHLabViterbiRecog
{
	CHLabViterbiRecogConfig  m_compMVConfig;
	CHLabPhoneList           m_phoneList;
	CHLabDict                m_dict;
	CHLabControl             m_control;
	CHLabTranscription       m_transcription;
	CHLabHMM*                m_pHMM;
	CHLabFeat                m_testFeat;
	CHLabViterbi*	  	     m_pViterbi;
	CHLabWordViterbi*        m_pWordViterbi;
	CHLabBPTable             m_BPTable;
	CHLabLM                  m_LM;
	
	
public:
	CHLabViterbiRecog(void);
	
	int ParseCommandLine(int argc, char** argv);

	
	 /**
      * Init
      * 
      * @param 
      * @return 
      */

	int Init(void);

	 /**
      * Run
      * 
      * @param 
      * @return 
      */

	int Run(void);

	virtual ~CHLabViterbiRecog(void);
};
