#include "HLabViterbiRecogConfig.h"

CHLabViterbiRecogConfig::CHLabViterbiRecogConfig(void)
{
}

CHLabViterbiRecogConfig::~CHLabViterbiRecogConfig(void)
{
}


arg_t CHLabViterbiRecogConfig::m_defn[] = 
{
	{"-phnlstfn",
	ARG_STRING,
	NULL,
	"PHoNe LiST File Name"},

	{"-modeldir",
	ARG_STRING,
	NULL,
	"Model directory name"},

	{"-dictfn",
	ARG_STRING,
	NULL,
	"DICTionary File Name"},


	{"-lmfn",
	ARG_STRING,
	NULL,
	"Language Model File Name"},

	{"-i",
	ARG_STRING,
	NULL,
	"Test feature file name"},

	{"-phonenum",
	ARG_INT32,
	"0",
	"Phone number FSN"},

	{"-wip",
	ARG_FLOAT64,
	"200.0",
	"Word insertion penalty"},

	
	{"-numstates",
	ARG_INT32,
	"3",
	"Number of states per HMM"},

	{"-lw",
	ARG_FLOAT64,
	"0.0",
	"Language Weight"},

	{"-beam",
	ARG_FLOAT64,
	"500.0",
	"Beam pruning threshold"},


	{ NULL, 0,  NULL, NULL }
};



int CHLabViterbiRecogConfig::ParseCommandLine(int argc, char** argv)
{
	print_appl_info(argv[0]);

	cmd_ln_appl_enter(argc, argv, "default.arg", m_defn);


	m_pszPhoneFile          = cmd_ln_str("-phnlstfn");
	m_pszDictFile           = cmd_ln_str("-dictfn");
	m_pszModelDir           = cmd_ln_str("-modeldir");
	m_pszInputFile          = cmd_ln_str("-i");
	m_pszLMFile             = cmd_ln_str("-lmfn");
	m_fWordInsertionPenalty = cmd_ln_float32("-wip");
	m_iPhoneNumber          = cmd_ln_int32("-phonenum");
	m_fBeam                 = cmd_ln_float32("-beam");
	m_fLMWeight             = cmd_ln_float32("-lw");

	m_iNumStatesPerHMM     = cmd_ln_int32("-numstates");
	
	print_appl_info(argv[0]);

	return (0);
}