#pragma once

#include "HLabConfig.h"

/**
* @file
* @author  Chanwoo Kim (chanwook@cs.cmu.edu)
* @version 1.0
*
* @section LICENSE
*
* @section DESCRIPTION
*
* The CHLabViterbiRecogConfig class is for forced alignment
* Viterbi processing is implemented in CHLabViterbi, but with that class,
* We cannot do state level backtracking.
*
*
*/

class CHLabViterbiRecogConfig :
	public CHLabConfig
{
	const char*  m_pszInputFile;
	const char*  m_pszLMFile;
	float        m_fWordInsertionPenalty;
	float        m_fLMWeight;
	int          m_iPhoneNumber;
	float        m_fBeam;
	static arg_t m_defn[];
	
public:
	CHLabViterbiRecogConfig(void);
	virtual ~CHLabViterbiRecogConfig(void);

	inline const char* GetInputFile(void)
	{
		return m_pszInputFile;
	}

	inline float GetWordInsertionPenalty(void)
	{
		return m_fWordInsertionPenalty;
	}

	inline float GetBeam(void)
	{
		return m_fBeam;
	}

	inline int GetPhoneNumberFlag(void)
	{
		return m_iPhoneNumber;
	}

	inline const char* GetLMFile(void)
	{
		return m_pszLMFile;
	}

	inline float GetLMWeight(void)
	{
		return m_fLMWeight;
	}

	int ParseCommandLine(int argc, char** argv);
};
